



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>利用Google Speech API实现Speech To Text</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">利用Google Speech API实现Speech To Text</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-27 01:42:21 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>很久很久以前, 网上流传着一个<strong><em>免费的,识别率暴高的,稳定的</em></strong> Speech To Text API, 那就是Google Speech API. 但是最近再使用的时候,总是返回500 Error.     后来通过查看源码知道需要增加一个参数:<code>key=...</code>. 可能是为了防止滥用吧. 并且, 最近Chrome另外发布了一个<strong><em>长连接实时</em></strong>的识别接口, 这对开发者来说真是巨大的福音啊. 在这里主要对这两个接口的用法进行介绍.</p>
<hr>
<ul><li>博客: <a href="http://www.cnblogs.com/jhzhu" rel="external nofollow noreferrer">http://www.cnblogs.com/jhzhu</a></li>
<li>邮箱: jhzhuustc@gmail.com</li>
<li>作者: 知明所以</li>
<li>时间: 2014-03-28</li></ul>
<hr>
<div></div>
<h2>关键字</h2>
<p>SpeechToText,API,google,STT,ASR,SR,speech,recognition</p>
<h2>申请Chromium API keys</h2>
<p>本文使用的Google Speech API是为google自家的浏览器Chrome服务的. 可以通过这个Demo体验一下实际使用的效果: <a href="https://www.google.com/intl/en/chrome/demos/speech.html" rel="external nofollow noreferrer">Google Speech To Text Demo</a>. <br /><br />
Chrome来源于开源项目Chromium. 为了方便开发者调试使用, google <strong><em>开放</em></strong>了这个STT(Speech to Text)接口. 但是, 因为这个借口只供调试使用, 所以在流量和次数上都有限制.并且, 不提供购买.</p>
<p>好了, 背景介绍完毕, 我们来第一步: <strong><em>申请Chromium开发者权限</em></strong>.  <br /><br />
具体步骤请参考<a href="http://www.chromium.org/developers/how-tos/api-keys" rel="external nofollow noreferrer">how to get chromium API keys</a>).</p>
<blockquote><p><strong><em>Acquiring Keys</em></strong></p>
<ol><li>Make sure you are a member of chromium-dev@chromium.org (you can just subscribe to chromium-dev and choose not to receive mail). <br /><br />
  For convenience, the APIs below are only visible to people subscribed to that group.</li>
<li>Make sure you are logged in with the Google account associated with the email address that you used to subscribe to chromium-dev.</li>
<li>Go to <a href="https://cloud.google.com/console" rel="external nofollow noreferrer">https://cloud.google.com/console</a>(请使用旧版console)</li>
<li>Click the red Create project… button.</li>
<li>(Optional) You may add other members of your organization or team on the Team tab.</li>
<li>In the ‘APIs &amp; auth’ &gt; APIs tab, click the On/Off button to turn each of the following APIs to the On position, and read and agree to the Terms of Service that is shown:<br>  <br /><br />
  (This list might be out of date; try searching for APIs starting with “Chrome” or having “for Chrome” in the name.)     * Chrome Remote Desktop API</p>
<ul><li>Chrome Spelling API</li>
<li>Chrome Suggest API</li>
<li>Chrome Sync API</li>
<li>Chrome Translate Element</li>
<li>Google Maps Geolocation API (requires enabling billing but is free to use; you can skip this one, in which case geolocation features of Chrome will not work)</li>
<li>Safe Browsing API</li>
<li><strong><em>Speech API</em></strong></li>
<li>Time Zone API</li>
<li>Google Cloud Messaging for Chrome</li>
<li>Google Now For Chrome API <br /><br />
  If any of these APIs are not shown, recheck step 1.</li></ul></li>
<li>Go to the Credentials tab under the APIs &amp; auth tab.</li>
<li>Click the red Create New Client ID button in the OAuth section to create an OAuth 2.0 client ID. <br>
<ul><li>You want “Installed Application” for the Application type section</li>
<li>You want “Other” for the Installed application type section</li></ul></li>
<li>A new box should now appear titled “Client ID for installed applications”. In the next sections, we will refer to the values of the “Client ID” and “Client secret” fields in this box later (below).</li>
<li>Click the red Create New Key button in the Public API Access section and create a new Browser key. <br /><br />
  You want to leave the box on the “Create a browser key and configure allowed referers” empty.</li>
<li>A new box should appear titled “Key for browser applications”. The next sections will refer to the value of the “API key” field too.</li></ol></blockquote>
<p>好了, 到这里, 我们已经获得了应用key, 在下文我们用<code>{key}</code>表示这个key.</p>
<h2>One Shot Recognition</h2>
<p>我们用<code>curl</code>来向服务器发送请求:</p>
<pre class="prettyprint linenums"><code>curl -X POST \<br />
--data-binary @speech.flac \<br />
--user-agent 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_6_8) AppleWebKit/535.7 (KHTML, like Gecko) Chrome/16.0.912.77 Safari/535.7' \<br />
--header 'Content-Type: audio/x-flac; rate=8000;' \<br />
'https://www.google.com/speech-api/v1/recognize?client=chromium&amp;lang=zh-CN&amp;maxresults=5&amp;pfilter=0&amp;key=AIzaSyC6Tkf4*****Q0CdISn-qnHhwLaS3cg2a0'  </code></pre>
<table>
<thead>
<tr>
<th>参数</th>
<th>解释</th>
</tr>
</thead>
<tbody>
<tr>
<td>-X POST</td>
<td>表示发送HTTP请求</td>
</tr>
<tr>
<td>–data-binary @speech.flac</td>
<td>发送音频文件<code>speech.flac</code></td>
</tr>
<tr>
<td>–user-agent ‘…’</td>
<td>http的参数,设置浏览器的<code>user-agent</code>信息</td>
</tr>
<tr>
<td>–header</td>
<td>http的参数. 指定了传送内容的类型(<code>audio/flac</code>)和音频频率(<code>8000Hz</code>). 注意, 只支持特定的几种频率(<code>8000Hz,4000Hz</code>还有几个记不清了),上传的flac文件频率要和参数一致.</td>
</tr>
<tr>
<td><a href="https://www.google.com/.../&amp;key=AIzaSyC6Tkf" rel="external nofollow noreferrer">https://www.google.com/…/&amp;key=AIzaSyC6Tkf</a>*****Q0CdISn-qnHhwLaS3cg2a0</td>
<td>http请求地址,其中最后一部分的key,应该替换为您申请的<code>{key}</code>.</td>
</tr>
</tbody>
</table>
<p>等待一分钟左右, 如果你运气好的话, 能看到如下结果: <br /><br />
<img referrerpolicy="no-referrer"src="https://lh4.googleusercontent.com/-fhssmr2ELnk/UzYp-0GSpXI/AAAAAAAACTc/hPtobP6kjmM/s0/SpeechResult.jpg"></p>
<p>结果格式如下, 应该很清晰了吧:</p>
<div></div>
<pre class="prettyprint linenums"><code>{<br />
    "status": 0,<br />
    "id": "b3447b5d98c5653e0067f35b32c0a8ca-1",<br />
    "hypotheses":<br />
    [<br />
        {<br />
            "utterance": "i like pickles",<br />
            "confidence": 0.9012539<br />
        },<br />
        {<br />
            "utterance": "i like pickle"<br />
        }<br />
    ]<br />
}</code></pre>
<p>如果您录音的格式不对的话, 可以用开源软件<code>sox</code>方便的转换格式和码率. 举个栗子:</p>
<pre class="prettyprint linenums"><code>sox ./speech.mp3 -b 8 speech.flac trim 0 15</code></pre>
<table>
<thead>
<tr>
<th>参数</th>
<th>解释</th>
</tr>
</thead>
<tbody>
<tr>
<td>./speech.mp3</td>
<td>输入文件</td>
</tr>
<tr>
<td>-b 8</td>
<td>输出文件频率为 8kHz</td>
</tr>
<tr>
<td>speech.flac</td>
<td>输出文件名</td>
</tr>
<tr>
<td>trim 0 15</td>
<td>截取输入文件的0~15秒的部分, 输出出来</td>
</tr>
</tbody>
</table>
<h2>Stream Recognition</h2>
<p>后来, Google 提供了更先进的live的双向的识别接口. 即同时打开两个HTTP连接, 一个负责实时发送(<code>POST</code>)音频流, 一个负责接受(<code>GET</code>). <br /><br />
这里有一个<code>PHP</code>版本的Demo. 可以参考实现您自己的<code>Stream Recognition</code>: <br /><br />
<a href="http://mikepultz.com/2013/07/google-speech-api-full-duplex-php-version/" rel="external nofollow noreferrer">Google Speech API – Full Duplex PHP Version</a></p>
<h2>引用:</h2>
<ol><li><p>Google Speech API – Full Duplex PHP Version <br /><br />
<a href="http://mikepultz.com/2013/07/google-speech-api-full-duplex-php-version/" rel="external nofollow noreferrer">http://mikepultz.com/2013/07/google-speech-api-full-duplex-php-version/</a></p></li>
<li><p>Accessing Google Speech API / Chrome 11 <br /><br />
<a href="http://mikepultz.com/2011/03/accessing-google-speech-api-chrome-11/" rel="external nofollow noreferrer">http://mikepultz.com/2011/03/accessing-google-speech-api-chrome-11/</a></p></li>
<li><p>Google Speech To Text API ( 9 months ago ) <br /><br />
<a href="https://gist.github.com/alotaiba/1730160" rel="external nofollow noreferrer">https://gist.github.com/alotaiba/1730160</a></p></li>
<li><p>避开Google Voice Search利用Google Speech API实现Android语音识别 <br /><br />
<a href="http://my.eoe.cn/sisuer/archive/5960.html" rel="external nofollow noreferrer">http://my.eoe.cn/sisuer/archive/5960.html</a></p></li>
<li><p>How to Use Google Speech API( with sox ) <br /><br />
<a href="http://www.x2q.net/blog/2013/09/16/how-to-use-google-speech-api/" rel="external nofollow noreferrer">http://www.x2q.net/blog/2013/09/16/how-to-use-google-speech-api/</a></p></li>
<li><p>Google Chomium Open Project <br /><br />
<a href="http://src.chromium.org/viewvc/chrome/trunk/src/content/browser/speech/" rel="external nofollow noreferrer">http://src.chromium.org/viewvc/chrome/trunk/src/content/browser/speech/</a> <br /><br />
<a href="http://src.chromium.org/viewvc/chrome/trunk/src/content/browser/speech/google_one_shot_remote_engine.cc" rel="external nofollow noreferrer">http://src.chromium.org/viewvc/chrome/trunk/src/content/browser/speech/google_one_shot_remote_engine.cc</a></p></li></ol>
<blockquote><p>Written with <a href="https://stackedit.io/" rel="external nofollow noreferrer">StackEdit</a>.</p></blockquote>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/9j0m55wq.html">微软职位内部推荐-Senior Development Lead</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnw2o0q.html">【狼窝乀野狼】Serializer妙手回春</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1317j9.html">myEclipse6&period;5与数据库（SQL Server2008）连接遇到的问题（自己总结的干货）&amp;lt&semi;用SSH框架的时候，用servlet&plus;javabean&plus;jsp的时候&amp;gt&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zy2k29.html">Windows服务器nginx&plus;tomcat服务负载均衡</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn14o6j8.html">JavaScript获取HTML页面源代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnvlle8.html">&lbrack;转&rsqb;The culture name list in C&num;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmw43l9.html">深入理解linux网络技术内幕读书笔记&lpar;八&rpar;--设备注册与初始化</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgdzwe8.html">UVA10006 - Carmichael Numbers</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp1mvj9.html">MSSQL - 自增1的标识列一次增长了1000</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g3do6q.html">Linux进程上下文切换过程context&lowbar;switch详解--Linux进程的管理与调度&lpar;二十一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1d2zeq.html">Visual Studio 2017 and Swagger&colon; Building and Documenting Web APIs</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvw6yx8.html">CSS 步骤进度条</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyogpdq.html">JQuery基本知识汇总；JQuery常用方法；浅入了解JQuery</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rory48.html">最短路（Bellman）-Hdu1874畅通工程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vmjo0q.html">Java使用线程并发库模拟弹夹装弹以及发射子弹的过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvlvomq.html">【Linux】关于Linux的部分细节与配置文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/902oo4nq.html">Zoie中文文档及简单解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qd5zgnz9.html">redis 笔记05    Sentinel、集群</a>
		</li>
						<li><a href="https://www.batexi.com/a/qndwvnj8.html">python学习之多线程&lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qndle6j8.html">jsp小知识点（2）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/0qw354l9.html">ViewPager和Fragment的组合使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql65jxq.html">&lbrack;moka同学笔记&rsqb;百度编辑器Ueditor自动换行，添加&amp;lt&semi;p&amp;gt&semi;的问题（摘录）</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4lnd08.html">CodeBlocks VS2015编译环境设置</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2p2wv8.html">ahjesus mongodb指定到数据盘连接不上的解决方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyz52m9.html">mysql命令行备份数据库</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rv1678.html">【OpenCV】选择ROI区域</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql6kgkq.html">galera cluster DDL节点间状态不一致的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qw3wnk9.html">【GOF23设计模式】组合模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4l6yn8.html">Upgrade custom workflow in SharePoint</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql6xx0q.html">适配iPhone6和iPhone6 Plus</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
